"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var ComplieTools_1 = require("./ComplieTools");
var fs = require("fs");
var fsExtra = require('fs-extra');
var UglifyJS = require("uglify-js");
var lzma = require('lzma');
var version_1 = require("../utils/version");
var BuildTools = (function (_super) {
    __extends(BuildTools, _super);
    function BuildTools() {
        var _this = _super.apply(this, arguments) || this;
        _this._watchMode = false;
        return _this;
    }
    BuildTools.prototype.enableWatchMode = function () {
        this._watchMode = true;
    };
    BuildTools.prototype._build = function () {
        this.complie();
        this.copyResource();
        this.addVersionNumber();
    };
    BuildTools.prototype.build = function () {
        var _this = this;
        if (this._watchMode) {
            var modulePath = this.getModulePath(this.getModuleName());
            fs.watch(modulePath, function () {
                _this._build();
            });
        }
        else {
            this._build();
        }
    };
    BuildTools.prototype.getBuildConfig = function () {
        var config = this.getModuleConfig(this.getModuleName());
        return config.build;
    };
    BuildTools.prototype.copyResource = function () {
        var config = this.getBuildConfig();
        if (config) {
            var enabled = config.copyResource === false ? false : true;
            if (enabled && config.copyResourceActions) {
                if (config.beforeCopyResource instanceof Function) {
                    config.beforeCopyResource();
                }
                for (var i in config.copyResourceActions) {
                    var action = config.copyResourceActions[i];
                    console.log('copy file ' + action.from + ' to ' + action.to);
                    fsExtra.copySync(action.from, action.to);
                }
                if (config.afterCompyResource instanceof Function) {
                    config.afterCompyResource();
                }
            }
        }
    };
    BuildTools.prototype.addVersionNumber = function () {
        var config = this.getBuildConfig();
        if (config) {
            var enabled = config.addVersionNumber === false ? false : true;
            if (enabled && config.needVersionFiles) {
                if (config.beforeAddVersionNumber instanceof Function) {
                    config.beforeAddVersionNumber();
                }
                version_1.addVersionNumberToFiles(config.needVersionFiles);
                if (config.afterAddVersionNumber instanceof Function) {
                    config.afterAddVersionNumber();
                }
            }
        }
    };
    BuildTools.prototype.readFile = function (file) {
        return fs.readFileSync(file, 'utf-8');
    };
    BuildTools.prototype.writeFile = function (file, content) {
        fs.writeFileSync(file, content, 'utf-8');
    };
    return BuildTools;
}(ComplieTools_1.ComplieTools));
exports.BuildTools = BuildTools;
//# sourceMappingURL=BuildTools.js.map